%global debug_package %{nil}
%global with_javadoc 1

Name:       fernflower
Version:    211.7442.40
Release:    1%{?dist}
Summary:    JIdea's java decompiler
License:    ASL 2.0 
URL:        https://github.com/JetBrains/intellij-community/tree/master/plugins/java-decompiler/engine

Source0:    %{name}-%{version}.tar.gz
Source1:    %{name}
Source2:    create-sources.sh

Patch0:     remove_main.patch
Patch1:     port_to_java_8.patch

BuildArch:  noarch
ExclusiveArch:  %{java_arches} noarch

BuildRequires:  javapackages-tools
BuildRequires:  java-devel
%if %{with_javadoc}
BuildRequires:  zip
%endif
Requires:      java-headless
Requires:      javapackages-tools
Provides:      %{name}-decompiler

%description
JIdea's decompiler is the first actually working analytical decompiler for Java and probably
for a high-level programming language in general. Naturally it is still under development,
please send your bug reports and improvement suggestions to the issue tracker.

%if %{with_javadoc}
%package javadoc
Summary: %{name} API documentation
Requires: javapackages-filesystem
BuildArch: noarch
Provides:  %{name}-decompiler-javadoc

%description javadoc
The %{name} 100% empty API documentation.
%endif

%prep
%setup
find | grep "\\.class$"
find | grep "\\.jar$"
rm -rvf test
rm -rvf testData
rm  -vf gradle/wrapper/gradle-wrapper.jar
find | grep "\\.class$" && exit 1
find | grep "\\.jar$"   && exit 1
%patch0
%patch1 -p1

%build
mkdir build
javac -source 8 -target 8 -d build `find src -type f`
cd build
jar -cf ../%{name}.jar  org
cd ..
mkdir build/libs
mv %{name}.jar build/libs/
%if %{with_javadoc}
mkdir fernflower-javadoc 
cd fernflower-javadoc 
javadoc `find ../src -type f`
cd ..
zip -r %{name}.zip fernflower-javadoc
%endif

%install
mkdir -p %{buildroot}/%{_bindir}/
cp %{SOURCE1}  %{buildroot}/%{_bindir}/ # cusotm launcher for main method in main jar
mkdir -p %{buildroot}/%{_javadir}/
cp  build/libs/%{name}.jar %{buildroot}/%{_javadir}
%if %{with_javadoc}
mkdir -p %{buildroot}/%{_javadocdir}/%{name}
cp %{name}.zip %{buildroot}/%{_javadocdir}/
%endif

%files
%license LICENSE.txt
%doc README.md
%{_javadir}/%{name}.jar
%attr(755, root, root) %{_bindir}/%{name}

%if %{with_javadoc}
%files javadoc
%license LICENSE.txt
%doc README.md
%{_javadocdir}/%{name}.zip
%endif

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 211.7442.40-1
- initial build
